2021-01-15 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSControl.m: Change encoding/decoding to protect
	against differences in integer size.

2021-01-08 Fred Kiefer <FredKiefer@gmx.de>

	* Headers/AppKit/NSComboBoxCell.h: Correct type of instance variables.
	* Source/GSGuiPrivate.h: Add macros for encoding/decoding.
	* Source/NSActionCell.m,
	* Source/NSButtonCell.m,
	* Source/NSCell.m,
	* Source/NSComboBoxCell.m,
	* Source/NSImageCell.m,
	* Source/NSLevelIndicatorCell.m,
	* Source/NSPathCell.m,
	* Source/NSPopUpButtonCell.m,
	* Source/NSSearchFieldCell.m,
	* Source/NSSliderCell.m,
	* Source/NSStepperCell.m: Change encoding/decoding to protect
	against differences in integer size.

2020-12-13 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSSearchFieldCell.m: Use GSTheme to display the popup.

2020-12-12 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSSearchField.m,
	* Source/NSSearchFieldCell.m: Small cleanups in formatting and
	int types.

2020-12-11 Riccardo Mottola <rm@gnu.org>

	* Source/GSToolbarView.m,
	Use centerScanRect to correct Items frame and avoid flickering.

2020-12-06 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSToolbarFrameworkPrivate.h,
	* Source/GSToolbarView.m,
	* Source/NSToolbar.m: Minor changes to format code, remove unused
	methods and introduce some new helper methods.

2020-11-29 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSMenuView.m (-mouseDown:): Protect against _window going
	away during tracking.

2020-11-23 Riccardo Mottola <rm@gnu.org>
	* Source/NSPopUpButtonCell.m (release):
	Use standard setMenu: in release and avoid leaking the Menu. (Proposed by Fred)

2020-11-03 Riccardo Mottola <rm@gnu.org>

	* Source/NSBitmapImageRep+JPEG.m (_JPEGRepresentationWithProperties:):
	Support greyscape output colorspace in JPEG decompression, fix Alpha output do NO, since JPEGs do not support it.

2020-10-18 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSTableView.m (-validateEditing): Reset _isValidating on
	intermediate return.
	Patch by Andreas Höschler <ahoesch@smartsoft.de>.

2020-10-04 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSColor.m: Protect against theme colour list missing out
	on default colours.

2020-09-14 Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSToolTips.m: Revert bogus last commit.

2020-09-12 Gregory John Casamento <greg.casamento@gmail.com>

	* Source/GSToolTips.m: Fix issue where setting the theme causes
	tooltips to become all black.  This is happening on windows and other
	platforms.
	* Source/NSCell.m: Fix for issue on Windows were contents are reset
	when initWithCoder: coder is called.  If the contents are set, they
	determine the type.  Currently investigating why this is occuring
	ONLY on Windows.

2020-09-12 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSTextView.m (-initWithCoder:): Make sure text container is
	in sync with the text view resize behaviour.
	* Source/NSScrollView.m (-initWithCoder:): Add scrollers as
	subviews when decoded.

2020-09-11 Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSLayoutManager.m
	(-glyphRangeForCharacterRange:actualCharacterRange:): Handle zero
	length charRagne at end of text correctly.

2020-09-07 Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSXib5KeyedUnarchiver.m
	(-decodeCellPrototypeForElement:): Fix misuse of setType:.

2020-07-28 Gregory John Casamento <greg.casamento@gmail.com>

	* Headers/AppKit/AppKit.h: Add all new headers
	* Headers/AppKit/NSTextCheckingClient.h: Protocol for
	NSTextCheckingController.m
	* Headers/AppKit/NSTextCheckingController.h: New controller
	for text checking - spelling/grammar
	* Headers/AppKit/NSTextFinder.h: Text finder, currently delegates
	all functionality to GSTextFinder.
	* Headers/AppKit/NSTextInputClient.h: Protocol
	* Headers/AppKit/NSTextInputContext.h: Protocol
	* Headers/AppKit/NSTextView.h: Implementation of methods needed
	for NSTextFinder.
	* Headers/AppKit/NSUserInterfaceValidation.h: Minor changes
	* MISSING: Removed these from MISSING list
	* Source/GNUmakefile: Add files to be compiled or copied to list.
	* Source/NSTextCheckingController.m: Implementation using
	NSSpellChecker
	* Source/NSTextFinder.m: Implementation using GSTextFinder
	* Source/NSTextInputContext.m: Skeleton implementation.
	* Source/NSTextView.m: Implementation of methods

2020-08-06 Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSStoryboardTransform.h,
	* Source/NSPageController.m,
	* Source/NSPersistentDocument.m,
	* Source/NSSplitViewItem.m,
	* Source/NSViewController.m: Fix compiler warnings mit gcc.

2020-07-31 Gregory John Casamento <greg.casamento@gmail.com>

	* Headers/AppKit/AppKit.h: Add header
	* Headers/AppKit/NSStatusBarButton.h: Declaration
	* MISSING: Remove file from list
	* Source/GNUmakefile: Add to compilation
	* Source/NSStatusBarButton.m: Definition of class.

2020-07-30 Gregory John Casamento <greg.casamento@gmail.com>

	* Headers/AppKit/AppKit.h
	* Headers/AppKit/NSLayoutAnchor.h
	* Headers/AppKit/NSLayoutConstraint.h
	* Headers/AppKit/NSLayoutGuide.h
	* MISSING: Remove classes from list.
	* Source/GNUmakefile
	* Source/GSXib5KeyedUnarchiver.m: Add code to decode constraints.
	* Source/NSLayoutAnchor.m
	* Source/NSLayoutConstraint.m
	* Source/NSLayoutGuide.m: Add infrastructure for layouts.
        This needs additional work and study.  Comitting now so others
        can more easily help.

2020-07-28 Gregory John Casamento <greg.casamento@gmail.com>

	* Headers/AppKit/AppKit.h: Add includes for splitviewcontroller,
        pagecontroller and tabviewcontroller.
	* Headers/AppKit/NSPageController.h: Interface for page view controller
	* Headers/AppKit/NSSplitViewController.h: Interface for splitview
        controller
	* Headers/AppKit/NSSplitViewItem.h: Enhancements to splitview item to
        add logic for controller
	* Headers/AppKit/NSStoryboardSegue.h: Add methods to handle popovers
	* Headers/AppKit/NSTabViewController.h: Interface for tabViewController
	* Headers/AppKit/NSTabViewItem.h: methods to support NSViewController
	* Headers/AppKit/NSToolbar.h: Minor changes to support tabview controller
	* Headers/AppKit/NSViewController.h: Additional enum
	* MISSING: Remove implemented classes from list
	* Source/GNUmakefile: Add new classes
	* Source/GSStoryboardTransform.h: Additional methods on proxy
	* Source/GSStoryboardTransform.m: Additional methods on proxy
	* Source/GSThemeDrawing.m: minor changes
	* Source/GSXib5KeyedUnarchiver.m: Handle pagecontroller element,
        set certain things to true if abesnt
	* Source/NSPageController.m: Implementation of NSPageController
	* Source/NSSplitViewController.m: Implementation of NSSplitViewController
	* Source/NSSplitViewItem.m: Implementation
	* Source/NSStoryboardSegue.m: New methods for segue
	* Source/NSTabViewController.m: Implementation of NSTabViewController
	* Source/NSTabViewItem.m: New methods implementation
	* Source/NSTabView.m: Add methods to handle NSViewController changes
	* Source/NSViewController.m: New methods.
	* Source/NSView.m: Private methods to insert a view
	* Source/NSViewPrivate.h: Private method to insert view, declaration
	* Source/NSWindow.m: Minor fixes.

2020-07-19 Gregory John Casamento <greg.casamento@gmail.com>

	* Headers/AppKit/AppKit.h: Add include files for NSSegue* and other
        classes.
	* Headers/AppKit/NSSeguePerforming.h: Protocol for segue performing
        so that classes that conform can be queried to determine if the
        segue should be performed in the first place.
	* Headers/AppKit/NSStoryboard.h: Class which loads the storyboard and
        loads the individual scenes and controllers.
	* Headers/AppKit/NSStoryboardSegue.h: This class handles the transition
        between controllers/scenes.
	* Headers/AppKit/NSViewController.h: Modifications to handle segues.
	* Headers/AppKit/NSWindowController.h: Modifications to handle segues.
	* Headers/AppKit/NSWindow.h: New method to create window controller for
        view controllers.
	* MISSING: Remove the classes implemented here from the missing list.
	* Source/Functions.m: Enhance NSApplicationMain() function to handle the
        loading of a storyboard.
	* Source/GNUmakefile: Add the new classes to the build and copy the
        headers.
	* Source/GSStoryboardTransform.[hm]: Class to handle the transformation
        of the storyboard file into "XIB" files for loading.  Also handles the
        intermediate
        processes of instantiation of the destination controller.
	* Source/NSStoryboard.m: Implementation of the above described class.
	* Source/NSStoryboardSegue.m: Implementation of the above described
        class.
	* Source/NSViewController.m: Implementation of private methods to
        handle transitions.
	* Source/NSWindowController.m: Implementation of private methods to
        handle transitions.
	* Source/NSWindow.m: Implementation of method to create window
        controller for view controllers.

2020-07-10 Gregory John Casamento <greg.casamento@gmail.com>

	* Headers/AppKit/NSOutlineView.h: Formalize protocols for
        NSOutlineViewDelegate and NSOutlineViewDataSource.

2020-07-03 Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSXib5KeyedUnarchiver.m (alternateName:): Be more careful
	when chopping of part of the name.

2020-07-03 Fred Kiefer <FredKiefer@gmx.de>

	* Headers/AppKit/NSNib.h,
	* Source/NSNib.m: Add missing MacOSX methods.
	* Source/GSXibLoader.m: Remove semicolon. Add debug logs.

2020-06-15 Gregory John Casamento <greg.casamento@gmail.com>

	* Headers/AppKit/AppKit.h
	* Headers/AppKit/NSAccessibilityCustomAction.h
	* Headers/AppKit/NSAccessibilityCustomRotor.h
	* Headers/AppKit/NSAccessibilityElement.h
	* Headers/AppKit/NSAccessibilityProtocols.h
	* Source/GNUmakefile
	* Source/NSAccessibilityCustomAction.m
	* Source/NSAccessibilityCustomRotor.m
	* Source/NSAccessibilityElement.m: Add skeletons for
        these classes. Future support of accessibility features
        will fill these in.

2020-06-12  Yavor Doganov  <yavor@gnu.org>

	* Headers/AppKit/NSApplication.h: Remove semicolons from the
	NSAppKitVersionNumber* definitions.

2020-05-29 Fred Kiefer <FredKiefer@gmx.de>

	* TextConverters/RTF/rtfGrammar.y: Correct encoding handling.
	* TextConverters/RTF/rtfGrammar.tab.h,
	* TextConverters/RTF/rtfGrammar.tab.m: Regenerated.
	* TextConverters/RTF/RTFConsumer.m: Add code to handle code page 10000.

2020-05-18 Fred Kiefer <FredKiefer@gmx.de>

	* Headers/AppKit/NSColor.h,
	* Source/NSColor.m: Add newer Cocoa methods.

2020-05-14 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSWindow.m (-makeFirstResponder, -sendEvent:): Correct
	handling of new first responder not becoming first responder.
	Patch suggested by Josh Freeman <pikopixel@twilightedge.com>.

2020-05-10 Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSXib5KeyedUnarchiver.m: Clean up NSPathCell decoding.

2020-05-09 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSStringDrawing.m: Initialize all the cache entries as
	not used.

2020-05-09 Gregory John Casamento <greg.casamento@gmail.com>

	* Source/NSPersistentDocument.[hm]: Add implementation of abstract
	class for NSPersistentDocument.

2020-05-09 Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSHorizontalTypesetter.m (_addExtraLineFragment): Make
	sure curParagraphStyle and line_height always have useful values.

2020-05-08 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSWindow.m (-initWithContentRect:...defer:): Call
	setFrame:display: to ensure the minium and maximum size gets enforced.
	* Source/NSFont.m (-description): Add this method.

2020-05-06 Gregory John Casamento <greg.casamento@gmail.com>

	* Headers/Additions/GNUstepGUI/GSTheme.h: Add declarations
        for new drawing methods.
	* Headers/AppKit/AppKit.h: Add headers to main header
	* Headers/AppKit/NSMenu.h: Add method to draw the popup in
        the appropriate positin
	* Headers/AppKit/NSPathCell.h: Implementation of path cell header
	* Headers/AppKit/NSPathComponentCell.h: Component cell
	* Headers/AppKit/NSPathControl.h: Control
	* Headers/AppKit/NSPathControlItem.h: Control item
	* MISSING: Remove NSPath* classes since they have been implemented
	* Source/GNUmakefile: Add files to compile and copy
	* Source/GSThemeDrawing.m: Add new drawing methods.
	* Source/GSXib5KeyedUnarchiver.m: Add new decoding methods
	* Source/NSMenu.m: Implement method to position popup
	* Source/NSPathCell.m: Implementation path cell.
	* Source/NSPathComponentCell.m: Cell representation of each
        component
	* Source/NSPathControlItem.m: Path items
	* Source/NSPathControl.m: Path control to contain path cell and
        components.

2020-04-30  Yavor Doganov  <yavor@gnu.org>

	* Documentation/GSSpeechRecognitionServer.1: Add simplistic
	manpage for GSSpeechRecognitionServer.
	* Documentation/GNUmakefile: Install it conditionally.

2020-04-26 Gregory John Casamento <greg.casamento@gmail.com>

	* Headers/Additions/GNUstepGUI/GSTheme.h: Add declarations
        for new drawing methods.
	* Headers/AppKit/AppKit.h: Add new headers
	* Headers/AppKit/NSAccessibilityProtocols.h
	* Headers/AppKit/NSCell.h: Add NSControlStateValue enum
	* Headers/AppKit/NSSwitch.h: Header for NSSwitch
	* MISSING: Remove NSSwitch
	* Source/GNUmakefile: Add .h and .m files
	* Source/GSThemeDrawing.m: Add drawing code for knob and
        switch basin.
	* Source/GSXib5KeyedUnarchiver.m: Add decoding for
        NSControlContents.  Make sure enabled is YES when not
        present.
	* Source/NSColor.m: Minor changes
	* Source/NSMatrix.m: Remove unneeded code
	* Source/NSSwitch.m: Implementation of NSSwitch
	* Source/NSToolbarItem.m: Remove unneeded code

2020-04-13 Gregory John Casamento <greg.casamento@gmail.com>

	* Headers/AppKit/AppKitErrors.h:
	* Headers/AppKit/AppKit.h:
	* Headers/AppKit/NSFontAssetRequest.h:
	* Headers/AppKit/NSMediaLibraryBrowserController.h:
	* Headers/AppKit/NSScrubber.h:
	* Headers/AppKit/NSScrubberItemView.h:
	* Headers/AppKit/NSScrubberLayout.h:
	* Headers/AppKit/NSSharingServicePickerToolbarItem.h:
	* Headers/AppKit/NSUserInterfaceCompression.h:
	* Headers/AppKit/NSUserInterfaceItemSearching.h:
	* Headers/AppKit/NSWindowRestoration.h:
	* MISSING: Remove mention of these classes.
	* Source/GNUmakefile
	* Source/NSFontAssetRequest.m:
	* Source/NSMediaLibraryBrowserController.m:
	* Source/NSScrubberItemView.m:
	* Source/NSScrubberLayout.m:
	* Source/NSScrubber.m:
	* Source/NSSharingServicePickerToolbarItem.m: Add code to allow
        compilation using these classes.  These are Mac specific so they
        can't be implemented on any other platform due to HW or
        service limitations.  At some point these might be able to be
        implemented, but, for now, they are here to allow apps which
        use them to compile.

2020-04-13  Ivan Vucica <ivan@vucica.net>

	* Documentation/announce.texi:
	* ANNOUNCE:
	Normalize the accompanying text for the release announcement across
	core packages: standardize chapter name and GPG information.

2020-04-05  Ivan Vucica  <ivan@vucica.net>

	* ANNOUNCE:
	* Documentation/ReleaseNotes.gsdoc:
	* Documentation/news.texi:
	* NEWS:
	Updating documentation for the 0.28.0 release.

2020-04-01  Wolfgang Lux  <wolfgang.lux@gmail.com>

	* Source/NSAlert.m (NSBeginAlertSheet): Restore call to delegate
	method which was lost a while ago.

	* Source/NSAlert.m (NSBeginCriticalAlertSheet,
	NSBeginInformationalAlertSheet): Remove redundant calls to close
	method.

	* Source/NSAlert.m (NSBeginAlertSheet, NSBeginCriticalAlertSheet,
	NSBeginInformationalAlertSheet): Change arguments names to reduce
	confusion about the intended use of the corresponding selectors.

2020-03-26 Fred Kiefer <FredKiefer@gmx.de>

	* Documentation/news.texi: Started to fill in some details for
	pending release.
	* .travis.yml: Try to keep up with Niels' changes in base.

2020-03-12  Sergii Stoian  <stoyan255@gmail.com>

	* Model/GNUmakefile: do not overwrite ADDITIONAL_INCLUDE_DIRS
	value to help RPM build. In spec file ADDITIONAL_INCLUDE_DIRS can be sat
	to subdirectories which are create by RPM build tool.

2020-03-05  Sergii Stoian  <stoyan255@gmail.com>

	* Source/NSWindow.m (_applyFrame:): new helper method to do actual
	resizing.
	(setFrame:display:): use _applyFrame method.
	(applicationDidChangeScreenParameters:): Use _applyFrame: because our
	origin in OpenStep coordinates might be unchanged and `setFrame:display:`
	has check for it.

2020-02-28  Sergii Stoian  <stoyan255@gmail.com>

	* Source/NSWindow.m (center): always center window on main screen -
	monitor where user expects to see window.

2020-02-26  Sergii Stoian  <stoyan255@gmail.com>

	* Source/NSWindow.m (sendEvent:): removed usage of extra local variables
	in GSAppKitWindowMoved code block.

2020-02-23  Sergii Stoian  <stoyan255@gmail.com>

	* Source/NSWindow.m
	(applicationDidChangeScreenParameters:): quit while loop after
	screen was found.
	(sendEvent:): use `_screen` ivar to get screen befor frame change.

	* Source/NSMenu.m (windowDidChangeScreen:): join two if statements.

2020-02-23 Fred Kiefer <FredKiefer@gmx.de>

	* Headers/Additions/GNUstepGUI/GSXibLoading.h,
	* Source/GSXib5KeyedUnarchiver.m,
	* Source/GSXibLoading.m: Move more behaviour from the
	IBActionConnection5 and IBOutletConnection5 classes
	to the original ones.

2020-02-23 Fred Kiefer <FredKiefer@gmx.de>

	* .travis.yml
	* travis-deps.sh: Try to keep up with Niels' changes in base.

2020-02-20  Sergii Stoian  <stoyan255@gmail.com>

	* Source/NSMenu.m (_setGeometry): take into account main screen
	origin when calculating horizontal menu postion.

	* Source/NSApplication.m (_appIconInit): take into account main screen
	origin when placing application icon.

2020-02-13  Sergii Stoian  <stoyan255@gmail.com>

	* Source/NSWindow.m (setFrame:display:): use _screeForFrame: here
	to prevent `_screen` reassign -  it will be reassigned in
	sendEvent: (GSAppKitWindowMoved event) after call to [self screen].
	(setFrameFromString:): removed unused code because _screenForFrame:
	never returns `nil`. Do not reassign `_screen` here.

2020-02-12  Sergii Stoian  <stoyan255@gmail.com>

	* Source/NSWindow.m (sendEvent:): set current screen to ivar and
	send WindowDidChangeScreen notification if window was moved to other
	screen.

	* Source/NSScreen.m (mainScreen): returns screen of main menu if no
	key window exists. With this implementation default screen (screen at
	index 0 in screens array) should never be returned.

	* Source/NSMenu.m (initWithTitle:): observe WindowDidBecomeKey and
	WindowDidChangeScreen notifications.
	(windowDidChangeScreen:): new method to handle observed notification
	added above. Moves menu to screen of key window for both cases: when
	key window moved to or activated on different screen.

2020-02-09 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSFontDescriptor.m: Correct key for encoding and decoding.

2020-01-31  Sergii Stoian  <stoyan255@gmail.com>

	* Source/GSTitleView.m (mouseDown:): limit menu movement to screen
	frame for top/left/right edges. Menu can be moved to the bottom until
	title is completely visible.

2020-01-27  Sergii Stoian  <stoyan255@gmail.com>

	* Source/NSWindow.m (applicationDidChangeScreenParameters): take into
	account screen origin change during window position recalculation.

2020-01-26  Sergii Stoian  <stoyan255@gmail.com>

	* Source/NSWindow.m (initWithContentRect:styleMask:backing:defer:):
	added observer of NSApplicationDidChangeScreenParametersNotification.
	(applicationDidChangeScreenParameters:): callback for added notification -
	updates window position, set new screen object and saves frame if
	autosave name exists.

2020-01-23 Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSXib5KeyedUnarchiver.m: Remove NSWindowTemplate5.
	* Source/GSXibLoader.m: Clean up code.
	* Headers/Additions/GNUstepGUI/GSXibKeyedUnarchiver.h,
	* Source/GSXibKeyedUnarchiver.m: Provide method to load both sorts
	of XIB files.
	* Source/NSArrayController.m: Add horrible hack to get KVB on
	array controller to work.

2020-01-22 Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSXib5KeyedUnarchiver.m,
	* Headers/Additions/GNUstepGUI/GSNibLoading.h,
	* Source/GSXibLoading.m: Move toolbar ivar from NSWindowTemplate5
	to NSWindowTemplate.

2020-01-22 Fred Kiefer <FredKiefer@gmx.de>

	* TextConverters/RTF/rtfScanner.m: Add RTFansicpg.
	* TextConverters/RTF/rtfGrammar.y: Handle encoding and code pages.
	* TextConverters/RTF/rtfGrammar.tab.h,
	* TextConverters/RTF/rtfGrammar.tab.m: Regenerated.
	* TextConverters/RTF/RTFConsumerFunctions.h,
	* TextConverters/RTF/RTFConsumer.m: Add code to handle encoding.

2020-01-20 Fred Kiefer <FredKiefer@gmx.de>

	* Headers/AppKit/NSAppearance.h,
	* Source/NSPDFInfo.m,
	* Source/NSWorkspace.m: Fix compiler warnings.

2020-01-19 Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSXibKeyedUnarchiver.m: Remove references of XIB 5.
	* Headers/Additions/GNUstepGUI/GSNibLoading.h: Add one method definition.
	* Source/GSXibLoader.m,
	* Source/GSXibLoading.m: Move helper classes to the correct file.

2020-01-19 Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSXib5KeyedUnarchiver.m: Handle dictionary elements correctly.
	* Source/NSKeyValueBinding.m: Transform each element of an array.

2020-01-18 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSArrayController.m: Only filter if there is a filter predicate.
	* Source/NSTableView.m: Use destionationValue instead of
	sourceValueFor: to get the row numbers and the display values.
	* Source/GSThemeDrawing.m: Don't use the datasource of the table
	directly to get the values to display.
	* Source/NSTabView.m: Mark for redisplay when removing tab item.
	* Source/NSKeyValueBinding.m: Add some debugging logs.

2020-01-12 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSToolbarItem.m (-initWithCoder:): Use decodeSizeForKey:.
	* Source/GSBindingHelpers.h,
	* Source/NSArrayController.m: Add observable array and use it for arrangeObjects.
	* Source/GSXib5KeyedUnarchiver.m: Add generic mechanism to decode
	keys that include the class name.
	Also add header clip view to subviews of scroller.

2020-01-11 Fred Kiefer <FredKiefer@gmx.de>

	* Headers/AppKit/NSRuleEditor.h
	* Source/NSRuleEditor.m: Add action and target.
	* Source/NSPredicateEditor.m: Add encoding and decoding.
	* Source/GSXib5KeyedUnarchiver.m: Decode row templates.

2020-01-10 Fred Kiefer <FredKiefer@gmx.de>

	* Headers/AppKit/NSKeyValueBinding.h,
	* Source/externs.m: Add some more bindings.
	* Source/NSPopUpButton.m,
	* Source/NSPopUpButtonCell.m,
	* Source/NSTableView.m: Use the new bindings.

2020-01-01 Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSXib5KeyedUnarchiver.m,
	* Source/GSXibKeyedUnarchiver.m,
	* Headers/Additions/GNUstepGUI/GSNibLoading.h,
	* Headers/Additions/GNUstepGUI/GSXibElement.h,
	* Headers/AppKit/NSCell.h,
	* Headers/AppKit/NSWindow.h,
	* Source/GSCodingFlags.h,
	* Source/GSNibLoading.m,
	* Source/GSXib5KeyedUnarchiver.h,
	* Source/GSXibElement.m,
	* Source/GSXibLoader.m,
	* Source/NSButtonCell.m,
	* Source/NSCell.m,
	* Source/NSMatrix.m,
	* Source/NSNibBindingConnector.m,
	* Source/NSToolbar.m:
	Merge XIB document loading from the old Eggplant branch with lots
	of cleanup.
	* Headers/Additions/GNUstepGUI/GSXibParser.h,
	* Source/GSXibParser.m,
	* Source/GNUmakefile: Remove now obsolete class.

2020-01-19 Fred Kiefer <FredKiefer@gmx.de>

	* Headers/AppKit/NSNibOutletConnector.h,
	* Headers/AppKit/NSNibControlConnector.h,
	* Source/NSNibOutletConnector.m,
	* Source/NSNibControlConnector.m,
	* Source/NSNibConnector.m: Add files missing in last commit from Gregory.

2020-01-10  Sergii Stoian  <stoyan255@gmail.com>

	* Images/common_StepperDown.tiff,
	* Images/common_StepperDownHighlighted.tiff,
	* Images/common_StepperUp.tiff,
	* Images/common_StepperUpHighlighted.tiff: new images with arrows
	similar to scroll view buttons'.

	* Source/GSThemeDrawing.m (stepperUpButtonRectWithFrame:),
	(stepperDownButtonRectWithFrame:): center buttons horizontally; simplify
	and cleanup.

	* Source/NSStepper.m (acceptsFirstResponder): return NO. Returning
	YES makes sense only if `keyDown:` is implemented.
	(acceptsFirstMouse:): return YES.

	* Source/NSStepperCell.m (cellSize): initial implementation. Returns
	minimum size based on up and button sizes.

2020-01-07 Fred Kiefer <FredKiefer@gmx.de>

	* Headers/AppKit/NSDatePicker.h,
	* Headers/AppKit/NSDatePickerCell.h,
	* Source/NSDatePicker.m,
	* Source/NSDatePickerCell.m: Small cleanup.
	* Headers/AppKit/AppKit.h
	* Headers/AppKit/NSPredicateEditor.h
	* Headers/AppKit/NSPredicateEditorRowTemplate.h
	* Headers/AppKit/NSRuleEditor.h
	* Source/GNUmakefile
	* Source/NSPredicateEditor.m
	* Source/NSPredicateEditorRowTemplate.m
	* Source/NSRuleEditor.m
	* Source/externs.m: Add minimal version of predicate editor copied
	over from mySTEP.

2020-01-06 Fred Kiefer <FredKiefer@gmx.de>

	* Headers/AppKit/NSDatePickerCell.h,
	* Headers/AppKit/NSDatePicker.h,
	* Source/NSDatePickerCell.m,
	* Source/NSDatePicker.m: Add minimal version of date picker copied
	over from mySTEP.

2019-12-29 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSBundleAdditions.m (-pathForNibResource:): Report type
	not filename while iterating.

2019-12-18  Sergii Stoian  <stoyan255@gmail.com>

	* Source/NSBrowser.m (frameOfColumn:): shift up column only for browser
	with separated columns layout.
	(tile): fix column height calculation; moved sanity check of column
	height closer to calculation; removed code that duplicates code below.

2019-12-17  Sergii Stoian  <stoyan255@gmail.com>

	* Source/NSScrollView.m (tile): tweak location and height of vertical
	scroller if header or corner view available.

	* Source/GSThemeDrawing.m: (drawTableCornerView:withClip:): do not draw
	black rectangle because -drawDarkButton:withClip: draws all necessary
	elements.

	* Source/GSThemeDrawing.m (drawScrollViewRect:inView:): further cleanup
	of method implementation. Removed all tweaks of scroller length - all
	required calculations must be done in NSScrollView's -tile method. Simplified
	caluclations of X and Y positions of scroller.

2019-12-17  Sergii Stoian  <stoyan255@gmail.com>

	* Source/GSThemeDrawing.m (drawScrollViewRect:inView:): fixed scroller
	border positionning and length - do not overlap border if any.
	Use [self sizeForBorderType: borderType] to determine border width.

2019-12-12  Sergii Stoian  <stoyan255@gmail.com>

	* Source/NSFont.m (smallSystemFontSize): return 10 as default value.
	Update documention comment regarding default values for NSMiniFontSize
	ans NSSmallFontSize.

2019-12-11  Sergii Stoian  <stoyan255@gmail.com>

	* Source/NSWindow.m
	(initialize): use MiniWindowTile image for miniwindow tile.
	(drawRect:): adjusted position of title cell to fit tile image.
	(setTitle:): disable drawing of title cell background;
	use NSMiniControlSize font size for miniwindow title cell.

	* Source/NSFont.m (systemFontSizeForControlSize:): increased default font
	size for NSMiniControlSize.

2019-12-11  Sergii Stoian  <stoyan255@gmail.com>

	* Source/GSHorizontalTypesetter.m: removed extra imports left from
	last 2 commits.

2019-12-10  Sergii Stoian  <stoyan255@gmail.com>

	* Headers/Additions/GNUstepGUI/GSLayoutManager.h,
	* Source/GSLayoutManager.m: new method -typingAttributes returns default
	typing attributes of NSTextView.
	* Source/NSLayoutManager.m: override GSLayoutManager's -typingAttributes
	- primitive method - provides access to _typingAttributes ivar.
	* Source/GSHorizontalTypesetter.m: use new GSLayoutManager's
	-typingAttributes method to get paragraph style and font of new empty text
	container. Normally `curLayoutManager` is a NSLayoutManager object so,
	actually, we get NSLayoutManager's _typingAttributes.

	* Source/GSHorizontalTypesetter.m: (_addExtraLineFragment) get paragraph
	style and font from NSLayoutManager's typing attributes. Fixes insertion
	point height for empty text objects (NSTextView, NSTexField etc.).

2019-12-09  Sergii Stoian  <stoyan255@gmail.com>

	* Source/NSStringDrawing.m: fixed incorrect string drawing (shortened, misplaced)
	in ART backend. It seems that third parameter to `cache_lookup` function
	(BOOL useScreenFonts) is valuable for ART but not for Cairo backend.

2019-12-07 Fred Kiefer <FredKiefer@gmx.de>

	* .travis.yml
	* travis-deps.sh: Try to keep up with Niels' changes in base.

2019-12-06 Fred Kiefer <FredKiefer@gmx.de>

	* Headers/AppKit/NSGestureRecognizer.h
	* Source/NSGestureRecognizer.m: Restore code by Daniel Ferreira
	* Headers/AppKit/NSButtonTouchBarItem.h
	* Headers/AppKit/NSCandidateListTouchBarItem.h
	* Headers/AppKit/NSClickGestureRecognizer.h
	* Headers/AppKit/NSColorPickerTouchBarItem.h
	* Headers/AppKit/NSCustomTouchBarItem.h
	* Headers/AppKit/NSGroupTouchBarItem.h
	* Headers/AppKit/NSMagnificationGestureRecognizer.h
	* Headers/AppKit/NSPanGestureRecognizer.h
	* Headers/AppKit/NSPickerTouchBarItem.h
	* Headers/AppKit/NSPopoverTouchBarItem.h
	* Headers/AppKit/NSPressGestureRecognizer.h
	* Headers/AppKit/NSRotationGestureRecognizer.h
	* Headers/AppKit/NSSharingServicePickerTouchBarItem.h
	* Headers/AppKit/NSSliderTouchBarItem.h
	* Headers/AppKit/NSStepperTouchBarItem.h
	* Headers/AppKit/NSTouchBarItem.h
	Clean up after Greg's commit.

2019-12-06 Fred Kiefer <FredKiefer@gmx.de>

	* .travis.yml
	* travis-deps.sh: Update to match changes in base by Niels Grewe.

2019-12-02 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSBitmapImageRep.m (-_convertToFormatBitsPerSample:...):
	Correct division by zero bug in image conversion.

2019-11-03 Riccardo Mottola <rm@gnu.org>

	* Headers/AppKit/NSWorkspace.h
	Remove fake typedef for NSAppleEventDescriptor since now we have a
	stub in Foundation.

2019-07-28 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSSliderCell.m: Fix encoding/decoding as the types don't match.
	* Source/NSApplication.m (-targetForAction:to:from:): Warn only in
	debug mode about the target not responding to the action.

2019-07-07 Fred Kiefer <FredKiefer@gmx.de>

	* Headers/AppKit/NSColor.h,
	* Source/NSColor.m: Add tool tip named colours.
	* Source/GSToolTips.m (+initialize, -_timedOut:): Get colours from NSColor.

2019-04-17  Sergii Stoian  <stoyan255@gmail.com>

	* Source/GSDragView.m (_setCursor): Do not hold `cursors` array -
	use NSCursor's methods. Do not recolor cursor and just use
	[NSCursor greenArrowCursor].

	* Headers/AppKit/NSCursor.h:
	* Source/NSCursor.m (greenArrowCursor):
	Use getStandardCursor() to get GSGreenArrowCursor. New cursor type
	GSGreeanArrowCursor was added.

	* Images/GSContextualMenuCursor.tiff,
	* Images/GSDisappearingItemCursor.tiff,
	* Images/GSDragCopyCursor.tiff,
	* Images/GSDragLinkCursor.tiff,
	* Images/GSGreenArrowCursor.tiff,
	* Images/GSOperationNotAllowedCursor.tiff: New cursor images.

	* Images/common_ClosedHandCursor.tiff,
	* Images/common_OpenHandCursor.tiff,
	* Images/common_copyCursor.tiff,
	* Images/common_linkCursor.tiff,
	* Images/common_noCursor.tiff: Removed from nsmapping.strings.

	* Images/GNUmakefile (Images_RESOURCE_FILES): Update resource
	list according to cursor images addition/removal.

2019-04-10  Sergii Stoian  <stoyan255@gmail.com>

	* Source/NSMenuItemCell.m (drawKeyEquivalentWithFrame:inView:):
	use NCell's textColor instead of check if we're disabled/enabled.

2019-04-10  Sergii Stoian  <stoyan255@ukr.net>

	* Source/NSMenuItemCell.m (drawKeyEquivalentWithFrame:inView:):
	check if item is disabled/enabled and set color attribute for attributed
	key equivalent string.

2019-04-09  Sergii Stoian  <stoyan255@gmail.com>

	* Source/NSMenuItemCell.m (_keyEquivalentString): if modifier key string
	is not defined - set key equivalent font trait: Italic for Alternate modifier
	Bold - for Control.
	(_sizeKeyEquivalentText:): new method to calculate string size wrt font
	set in `_keyEquivalentString:`.
	(drawKeyEquivalentWithFrame:inView:): draw key equivalent as attributed
	string.

2019-04-08  Sergii Stoian  <stoyan255@ukr.net>

	* Source/NSApplication.m (becomesKeyOnlyIfNeeded): override NSWindow
	methodin appicon to reduce number of order front calls. The source
	of the call is NSWindow's sendEvent:.

2019-04-06  Sergii Stoian  <stoyan255@ukr.net>

	* Headers/Additions/GNUstepGUI/GSDisplayServer.h,
	* Source/NSApplication.m,
	* Source/GSDisplayServer.m: `hidewindow` method  was renamed to
	`hideApplication`

	* Source/NSApplication.m (hide:): Change comment before call to
	`hidewindow`.

	* Source/GSDisplayServer.m (hidewindow:): fixes to return value and type.
	Change comment.

2019-04-05  Sergii Stoian  <stoyan255@gmail.com>

	* Headers/AppKit/NSEvent.h: new event subtype `GSAppKitAppHide` was added.
	* Source/NSWindow.m (sendEvent:): handle "GSAppKitAppHide" event subtype.

	* Headers/Additions/GNUstepGUI/GSDisplayServer.h,
	* Source/GSDisplayServer.m (hidewindow:): new methods was added.

	* Source/NSApplication.m (hide:): Send -hidewindow: to to the main menu.
	If window manager doesn't support _GNUSTEP_HIDE_APP atom - hide windows
	by ourself.

2019-04-03  Sergii Stoian  <stoyan255@ukr.net>

	* Source/NSApplication.m (activateIgnoringOtherApps:):
	Optimize `-autolaunch YES` checking code.

2019-04-02  Sergii Stoian  <stoyan255@gmail.com>

	* Source/NSApplication.m:
	(activateIgnoringOtherApps:) Do not activate application on first run
	if commandline argument `-autolaunch YES` was specified.

2019-03-27  Sergii Stoian  <stoyan255@gmail.com>

	* Headers/AppKit/NSWindow.h:
	Lowering down NSFloatingWindowLevel number by one to distinguish
	floating panels from menus.

2019-02-26 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSBitmapImageRep+ICNS.m (_imageRepsWithICNSData:): Try to
	put the best suited image first.

2019-02-10 Fred Kiefer <FredKiefer@gmx.de>

	* Headers/Additions/GNUstepGUI/GSHorizontalTypesetter.h: Add
	comment to describe cache variables.
	* Source/GSHorizontalTypesetter.m: Restructure glyph attribute
	cache filling and make _addExtraLineFragment saver by providing a
	default for curParagraphStyle.

2019-01-21 Riccardo Mottola <rm@gnu.org>

	* Source/NSWorkspace.m
	Do guard includes for getmntinfo and mntent separately, should
	help building on Debian/kFreeBSD and fix 55526, but could need
	more work.

2019-01-06 Ivan Vucica <ivan@vucica.net>

	* ANNOUNCE
	* Documentation/ReleaseNotes.gsdoc
	* Documentation/news.texi
	* NEWS
	* Version:
	Updating documentation for the 0.27.0 release.

2019-01-06 Ivan Vucica <ivan@vucica.net>

	* configure: Regenerated with autoconf 2.69.

2019-01-05 Fred Kiefer <FredKiefer@gmx.de>

	* Documentation/news.texi: Fill in some details for pending release.
	* Source/NSTableView.m (encodeWithCoder:,initWithCoder:): Use
	unsigned int instead of unsigned long for flags.

2018-11-19 Riccardo Mottola <rm@gnu.org>

	* Headers/Additions/GNUstepGUI/config.h.in
	* configure
	* configure.ac
	New getmntent structure checks.

	* Source/NSWorkspace.m (getFileSystemInfoForPath)
	On linux, try to read /sys/block/xxx/removable information to get
	information about removable volumes, while continue honoring
	preferences. This can be a little inefficient if called for each volume.
	Furthermore in mountedLocalVolumePaths, enhance skipping reserved mount
	names by using filesystem type also if getmmntent is available.

2018-09-14 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSGraphicsContext.m
	(+graphicsContextWithGraphicsPort:flipped:): Rewrite using an init method.

2018-08-05    <wolfgang.lux@gmail.com>

	* Source/NSApplication.m (-setApplicationIconImage:): Avoid
	calling iconSize method on a null pointer.

2018-08-03 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSApplication.m (-applicationIconImage): Lazy load the
	app icon.

2018-07-27 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSView.m (-beginPageInRect:atPlacement): Remove check for
	empty rect. This will now use the placement translation all the time.

2018-07-14 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSPrinter.m (-addPPDKeyword:withScanner:withPPDPath:):
	Protect against value being nil.
	* Source/NSPageLayout.m (-tableView:objectValueForTableColumn:row:):
	With standard papers, calculate margins taking into account factorValue.
	* Source/NSPrintInfo.m (-initWithDictionary): Fix border calculation.
	Idea by Yavor Doganov <yavor@gnu.org>

2018-07-08 Ivan Vucica <ivan@vucica.net>

	* Source/NSOpenGLView.m:
	Fix docstring for -[NSOpenGLView initWithFrame:pixelFormat:].
	There is no such thing as +[NSOpenGLContext defaultPixelFormat].

2018-06-11 Riccardo Mottola <rm@gnu.org>

	* Headers/Additions/GNUstepGUI/config.h.in
	* configure
	* configure.ac
	* Source/NSBitmapImageRep+JPEG.m
	Check for floorf() and provide simple replacement.

2018-06-04 Stjepan Brkić <stjepanbrkicc@gmail.com>

	* Headers/AppKit/NSView.h: Add 'id _coreAnimationData' variable.
	The variable will point to another class instance that will
	contain data necessary data for future implementation of methods
	regarding CA layers.

2018-03-30 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSDocument.m (-revertToContentsOfURL:ofType:error:): Add
	override calls for deprecated methods.

2018-03-29  Graham Lee  <graham@iamleeg.com>

	* Source/NSWindowController.m: gsdoc

2018-03-11 Fred Kiefer <FredKiefer@gmx.de>

	* Headers/AppKit/NSSliderCell.h,
	* Source/NSSliderCell.m: Rewrite this class to store and access
	the value directly. This brings the behaviour closer to Apple's
	horrible implementation.

2018-02-27 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSSegmentedCell.m (-startTrackingAt:inView:,
	-continueTracking:at:inView:): Add this methods to enable
	tracking for this class.
	Patch suggested by Josh Freeman <pikopixel@twilightedge.com>.

2018-02-27 Fred Kiefer <FredKiefer@gmx.de>

	* Headers/Additions/GNUstepGUI/GSTheme.h,
	* Source/GSThemeDrawing.m: Correct int/NSInteger mismatch detected
	by Josh Freeman <pikopixel@twilightedge.com>.

2018-02-25 Fred Kiefer <FredKiefer@gmx.de>

	* Headers/AppKit/NSKeyValueBinding.h,
	* Source/NSKeyValueBinding.m: Add helper function NSIsControllerMarker.

2018-02-09 Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSDisplayServer.m: Store the current display server in a
	static variable and not in a thread variable.
	Idea by Yavor Doganov  <yavor@gnu.org>

2018-02-05 Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSHorizontalTypesetter.m (-layoutLineNewParagraph:): Make
	sure nominal gets always set.

2018-02-04 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSAlert.m (NSBeginAlertSheet): Move closing the sheet from
	here...
	* Source/NSApplication.m (-beginSheet:...:contextInfo:): ...to here.

2018-01-29 Fred Kiefer <FredKiefer@gmx.de>

	* Tools/speech/GNUmakefile,
	* configure.ac: Give up on dynamic library detecion.
	* configure: Regnerate

2018-01-29 Fred Kiefer <FredKiefer@gmx.de>

	* configure.ac: Correct last commit.
	* configure: Regnerate

2018-01-28 Fred Kiefer <FredKiefer@gmx.de>

	* configure.ac: Improve checks for flite.
	* configure: Regnerate
	* Tools/speech/GNUmakefile: Use variables for flite libraries.
	* Tools/speech/FliteSpeechEngine.m: Switch to use register_cmu_us_kal16.

2018-01-24 Fred Kiefer <FredKiefer@gmx.de>

	* Printing/GSCUPS/GSCUPSPrintOperation.m:
	Restore -allocWithZone: methods as this is needed to override
	behaviour in superclass.

2018-01-23 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSApplication.m (-targetForAction:to:from:): Warn about
	the target not responding to the action.
	* Source/NSSavePanel.m (_initWithoutGModel): Don't set the OK
	button as the target of the browser. Use helper method instead.

2018-01-22 Gregory John Casamento <greg.casamento@gmail.com>

	* Tools/speech/GSSpeechSynthesizer.m: Correct compilation
	error in for loop in connectionDied: method.

2018-01-21 Fred Kiefer <FredKiefer@gmx.de>

	* Tools/speech/GNUmakefile: Remove specific OBJC flags.
	Fixes bug #46939.

2018-01-14 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSMenu.m (-update): Restructure by splitting up into two
	helper methods.
	* Source/NSMenu.m (-performKeyEquivalent:): Use new helper method
	to only autoenable menu item with matching key equivalent.

2018-01-14 Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSLayoutManager.m
	(-glyphRangeForCharacterRange:actualCharacterRange:): Try to
	handle attachments at the end of the file more graceful.

2018-01-07 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSView.m (-_rebuildCoordinates): Use simple path only
	when both window and superview are nil. Set the visibleRect in
	this case to bounds.

2018-01-07 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSApplication.m (-targetForAction:to:from:): Return nil
	if the target is non-nil but does not respond to the action.

2018-01-01 Ivan Vucica <ivan@vucica.net>

	* ANNOUNCE
	* Documentation/ReleaseNotes.gsdoc
	* Documentation/news.texi
	* NEWS
	* Version:
	Updating documentation for the 0.26.2 release.

2018-01-01 Fred Kiefer <FredKiefer@gmx.de>

	* Printing/GSCUPS/GSCUPSPrinter.m,
	* Printing/GSCUPS/GSCUPSPrintInfo.m:
	Restore -allocWithZone: methods as this is needed to override
	behaviour in superclass.

2018-01-01  Yavor Doganov <yavor@gnu.org>

	* Documentation/make_services.1: Typo fix.

2018-01-01 Fred Kiefer <FredKiefer@gmx.de>

	* config/pkg.m4: Update to serial 12.
	* Headers/Additions/GNUstepGUI/config.h.in,
	* configure: Regnerate
	Fixes bug #52779.
	Patch by Yavor Doganov <yavor@gnu.org>

2017-12-31 Ivan Vucica <ivan@vucica.net>

	* Documentation/announce.texi
	* Documentation/news.texi
	* Documentation/ReleaseNotes.gsdoc
	* ANNOUNCE
	* NEWS
	* Version: Cut a new release of gnustep-gui which requires
	gnustep-base 1.25.1.

2017-12-28 Fred Kiefer <FredKiefer@gmx.de>

	* Tests/gui/NSBezierPath/windingCountAtPoint.m
	* Tests/gui/NSCell/basic.m
	* Tests/gui/NSEvent/delta.m
	* Tests/gui/NSPasteboard/lazy_copy.m
	* Tests/gui/NSSavePanel/setDelegate_reload.m
	* Tests/gui/NSSliderCell/minMax.m
	Remove comipler warnings in test code.
	* Tests/gui/TextSystem/deallocation.m
	Move auto release pool inside of the test set to get the test
	working again.

2017-12-28 Fred Kiefer <FredKiefer@gmx.de>

	* Printing/GSCUPS/GSCUPSPrinter.m,
	* Printing/GSCUPS/GSCUPSPrintInfo.m,
	* Printing/GSCUPS/GSCUPSPrintOperation.m: Undefine __BLOCKS__
	before the cups.h import as some versions of this header file
	expect unconditional that libdispatch is present when that
	variable is defined.
	Remove duplicated -allocWithZone: methods.

2017-12-27 Richard Frith-Macdonald <rfm@gnu.org>

	* Source/NSGraphicsContext.m:  When using clang and the gnustep
	runtime (the nonfragile API), it seems the compiler calculates the
	offset of the _gcontext instance variable in the NSThread object
	incorrectly, causing a crash.
	Until we know why and can fix it, we need a workaround.  The simplest
	one would be not to use the instance variable at all, but on the
	assumption that the instance variable was added to address a real
 	performance issue it seems better to use the runtime to access the
	instance variable.

2017-12-10 Ivan Vucica <ivan@vucica.net>

	* NEWS: Regenerate NEWS file for the 0.26.0 release.

2017-12-07 Ivan Vucica <ivan@vucica.net>

	* Documentation/announce.texi: Use GNUSTEP-GUI-VERSION even when
	talking about -back.
	* Documentation/ReleaseNotes.gsdoc:
	* Documentation/news.texi: Update with notable changes for 0.26.0.
	* ANNOUNCE: Regenerated the ANNOUNCE file from announce.texi and
	news.texi.

2017-12-07 Ivan Vucica <ivan@vucica.net>

	* Source/NSImage.m (-initWithCoder:): Clean up and reduce amount
	of releases of self.

2017-12-03 Fred Kiefer <FredKiefer@gmx.de>

	* Headers/AppKit/NSScreen.h
	* Source/NSScreen.m (-backingScaleFactor): Add new method. Change
	return value of -userSpaceScaleFactor to CGFloat.
	* Source/NSWindow.m (-backingScaleFactor): Return 1 instead of 0.

2017-10-28  Graham Lee  <graham@iamleeg.com>

	* Source/NSImage.m (initWithCoder:): restore image name when
	loading an archived image with a name that can't be resolved at
	load time. Fixes Gorm bug #46317.

2017-10-05 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSMenu.m (-isPartlyOffScreen): Protect agains window or
	screen being nil.
	* Source/NSWindow.m (-_screenForFrame:): Try not to return nil, as
	other code uses the result without checks.

2017-10-01 Ivan Vucica <ivan@vucica.net>

	* Documentation/ReleaseNotes.gsdoc:
	Backfill 0.24.1 through 0.25.1. Add stub 0.26.0 entry.

	* Documentation/news.texi:
	Add stub 0.26.0 entry.

	* Version:
	Bump to 0.26.0.

2017-08-31 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSStepperCell.m (-trackMouse:...untilMouseUp:): Adjust
	to changes in super class.

2017-08-27 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSButtonCell.m (-setButtonType:): Warn about unsupported
	button types.
	* Source/NSCell.m (-performClickWithFrame:inView:): Highlight the
	cell only if drawing is possible.

2017-08-27 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSCell.m (-trackMouse:...untilMouseUp:): Rewrote mouse
	tracking logic to be closer to the Cocoa definition.

2017-08-25 Riccardo Mottola <rm@gnu.org>

	* Source/NSBitmapImageRep.m
	Initialize density to 0, so that in case it is unset (72dpi) it is
	not a random value in case the struct is not zeroed.

2017-08-24  Daniel Ferreira <dtf@stanford.edu>

	* Source/externs.m:
	Define some private NSAttributedString attribute name definitions. Their
	functionality is not yet implemented.

2017-08-24  Daniel Ferreira <dtf@stanford.edu>

	* Headers/AppKit/NSWindow.h:
	Define new values for the NSWindowCollectionBehavior enum for
	compatibility purposes.

2017-08-24  Daniel Ferreira <dtf@stanford.edu>

	* Headers/AppKit/NSGestureRecognizer.h
	* Source/NSGestureRecognizer.m:
	Implement stub for -[NSGestureRecognizer locationInView:] for
	compatibility purposes.

	* Headers/AppKit/NSWindow.h
	* Source/NSWindow.m:
	Add stub for +[NSWindow windowNumberAtPoint:belowWindowWithWindowNumber:]
	for compatibility purposes.

	* Headers/AppKit/NSSpellChecker.h
	* Source/NSSpellChecker.m:
	Add a stub for the -checkGrammarOfString:... method for compatibility
	purposes.

	* Headers/AppKit/NSSpellChecker.h
	* Source/NSSpellChecker.m:
	Add stubs for:
	- +[NSSpellChecker isAutomaticTextReplacementEnabled],
	- +[NSSpellChecker isAutomaticDashSubstitutionEnabled]
	- +[NSSpellChecker isAutomaticQuoteSubstitutionEnabled]
	for compatibility purposes.

2017-08-15  Daniel Ferreira <dtf@stanford.edu>

	* Headers/AppKit/NSDragging.h:
	Create NSDraggingSource protocol for increased compatibility with GUI.

	* Headers/AppKit/NSSpellChecker.h:
	Add definitions for the NSCorrectionResponse for increased
	compatibility.

	* Headers/AppKit/NSWindow.h
	* Source/NSWindow.m:
	Add stub for -[NSWindow backingScaleFactor] for compatibility purposes.

	* Headers/AppKit/NSApplication.h
	* Headers/AppKit/NSWindow.h
	* Source/NSWindow.m:
	Define constants and stubs related to modal sheets in GUI for increased
	compatibility.

	* Headers/AppKit/NSFont.h
	* Source/externs.m:
	Define font weight constants introduced in macOS 10.11.

	* Source/externs.m:
	Export the private _NXSmartPaste constant for compatibility purposes.

	* Headers/AppKit/NSAttributedString.h
	* Source/externs.m:
	Add a stub for NSTextInsertionUndoableAttributeName, a private
	NSAttributedString attribute.

	* Headers/AppKit/NSButtonCell.h:
	Define new button cell constants in the NSButtonCell header. These
	buttons are not yet implemented, however.

	* Headers/AppKit/NSText.h:
	Define new-style NSTextAlignment* constants on GUI for compatibility
	purposes with new macOS versions.

2017-08-09  Svetlana Tkachenko

	*  ColorPickers/Russian.lproj/StandardPicker.strings
	Add translation.

2017-08-04  Daniel Ferreira <dtf@stanford.edu>

	* .travis.yml
	* travis-deps.sh:
	Add a Travis CI build to gnustep-gui to check if everything is really
	okay before accepting patches.

	Recent events have shown that bad patches have passed through the review
	process, specially when it comes to breaking compatibility with GCC. A
	CI routine would distinctly avoid these cases.

2017-08-04 Alex Myczko <alex@aiei.ch>

	* ColorPickers/Polish.lproj: Added translation.

2017-08-02 Alex Myczko <alex@aiei.ch>

	* ColorPickers/German.lproj: Added translation.

2017-07-31 Fred Kiefer <FredKiefer@gmx.de>

	* Headers/AppKit/NSPasteboardItem.h
	* Source/NSPasteboardItem.m: Clean up these files.

2017-07-31 Ivan Vucica <ivan@vucica.net>

	* Source/NSTextList.m: Add _startingItemNumber-related TODOs to
	NSTextList.
	* Source/NSPasteboardItem.m: Remove RETAIN() when returning
	-[NSPasteboardItem types].

2017-07-28 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSMenuView.m (-attachSubmenuForItemAtIndex:): We should
	not use [NSMenu display] for NSWindows95InterfaceStyle as there we
	have two NSMenuViews for the NSMenu.

2017-07-28 Riccardo Mottola <rm@gnu.org>

	* Headers/AppKit/NSRunningApplication.h: We can actually use retain
	as an equivalent property when not using ARC.

2017-07-26 Fred Kiefer <FredKiefer@gmx.de>

	* Headers/AppKit/NSRunningApplication.h: Remove property attribute
	"strong" as gcc does not support this.

2017-07-26  Daniel Ferreira <dtf@stanford.edu>

	* Headers/AppKit/NSTextList.h
	* Source/NSTextList.m:
	Add the `startingItemNumber` property to NSTextList introduced in macOS
	10.6.

2017-07-26  Daniel Ferreira <dtf@stanford.edu>

	* Headers/AppKit/AppKit.h
	* Headers/AppKit/NSPasteboardItem.h
	* Source/GNUmakefile
	* Source/NSPasteboardItem.m:
	Implement the NSPasteboardItem class. For now, it remains relatively
	useless since NSPasteboard does not yet know how to use it. However, it
	should be pluggable into NSPasteboard once NSPasteboard learns about
	NSPasteboardReading and NSPasteboardWriting.

	* Headers/AppKit/NSPasteboard.h:
	Define the NSPasteboardReading and NSPasteboardWriting protocols
	introduced in OSX 10.6, which remain unimplemented in NSPasteboard.

2017-07-26  Daniel Ferreira <dtf@stanford.edu>

	* Headers/AppKit/AppKit.h
	* Headers/AppKit/NSTextAlternatives.h
	* Source/GNUmakefile
	* Source/NSTextAlternatives.m:
	Implement NSTextAlternatives, a class usually used for choosing
	alternatives from a basic string usually for dictation purposes.

2017-07-26  Daniel Ferreira <dtf@stanford.edu>

	* Headers/AppKit/NSScroller.h
	* Source/NSScroller.m:
	As of macOS 10.7, scrollers gained two types: Legacy and Overlay. Here,
	we define these styles as well as a method to determine which is the
	"default" style to be used.

2017-07-25 Riccardo Mottola <rm@gnu.org>

	* Source/externs.m
	Do not initialize a string constant with another string constant
	or it breaks GCC build as is. Better proposals to ensure the exact
	same string pointer is used welcome.

2017-07-25  Daniel Ferreira <dtf@stanford.edu>

	* Headers/AppKit/NSAttributedString.h
	* Source/externs.m:
	Define an (unimplemented) NSAttributedString attribute for an
	NSTextAlternatives object.

	Define an (unimplemented) NSAttributedString attribute for Unicode
	writing direction.

	* Headers/AppKit/NSParagraphStyle.h
	* Headers/AppKit/NSText.h:
	Define constants for defining an attributed string's writing direction.

2017-07-25  Daniel Ferreira <dtf@stanford.edu>

	* Headers/AppKit/NSCell.h
	* Headers/AppKit/NSView.h
	* Source/NSCell.m
	* Source/NSView.m:
	Implement stubs for the layout direction properties in NSCell and
	NSView. Currently, they default to left-to-right layouting.

2017-07-25  Daniel Ferreira <dtf@stanford.edu>

	* Headers/AppKit/AppKit.h
	* Headers/AppKit/NSAccessibility.h
	* Headers/AppKit/NSAccessibilityConstants.h
	* Source/GNUmakefile
	* Source/NSAccessibility.m:
	Declare base NSAccessibility functions and constants, which have been
	implemented as stubs.

2017-07-25  Daniel Ferreira <dtf@stanford.edu>

	* Headers/AppKit/NSWindow.h:
	Define a missing enum value for a window mask. This mask remains
	unimplemented.

2017-07-25  Daniel Ferreira <dtf@stanford.edu>

	* Headers/AppKit/NSControl.h
	* Source/NSControl.m:
	Create a stub for the -[NSControl sizeThatFits:] function.

2017-07-25  Daniel Ferreira <dtf@stanford.edu>

	* Headers/AppKit/NSScrollView.h
	* Source/NSScrollView.m:
	Create stubs for the content/scroller inset properties in NSScrollView.

2017-07-25  Daniel Ferreira <dtf@stanford.edu>
	* Headers/AppKit/AppKit.h
	* Source/GNUmakefile:
	Create new classes in the GUI library.

	* Headers/AppKit/NSRunningApplication.h
	* Source/NSRunningApplication.m:
	Create a stub for the NSRunningApplication class.

	* Headers/AppKit/NSGestureRecognizer.h
	* Source/NSGestureRecognizer.m:
	Create stub for the NSGestureRecognizer class.

	* Headers/AppKit/NSVisualEffectView.h
	* Source/NSVisualEffectView.m:
	Create stub for the NSVisualEffectView class.

2017-07-25  Daniel Ferreira <dtf@stanford.edu>
	* Headers/AppKit/NSSpeechSynthesizer.h
	* Source/NSSpeechSynthesizer.m:
	Define new constants in NSSpeechSynthesizer. These are not yet handled
	by the implementation.

	* Headers/AppKit/NSSpellChecker.h:
	Define new constants on NSSpellChecker. They are not yet handled by the
	implementation.

2017-07-25  Daniel Ferreira <dtf@stanford.edu>

	* Headers/AppKit/AppKit.h
	* Headers/AppKit/NSUserInterfaceLayout.h
	* Source/GNUmakefile:
	Define interface layout enums to be used by AppKit. This improves
	compatibility with the reference platform.

2017-07-25  Daniel Ferreira <dtf@stanford.edu>

	* Headers/AppKit/AppKit.h
	* Headers/AppKit/NSUserInterfaceItemIdentification.h
	* Source/GNUmakefile:
	Introduce the NSUserInterfaceItemIdentification protocol, which required
	an user interface class provide an unique identifier.

2017-07-25  Daniel Ferreira <dtf@stanford.edu>

	* Headers/AppKit/AppKit.h
	* Headers/AppKit/NSSharingService.h
	* Source/GNUmakefile
	* Source/NSSharingService.m:
	Define the NSSharingService class as an unimplemented stub for
	compatibility purposes.

2017-07-25  Daniel Ferreira <dtf@stanford.edu>

	* Headers/AppKit/NSView.h
	* Source/NSView.m:
	Define layer-related properties in NSView for compatibility purposes,
	and keep their getters and setters as stubs, since they will not have
	any effect before NSView-CALayer integration is implemented.

2017-07-25  Daniel Ferreira <dtf@stanford.edu>

	* Headers/AppKit/NSPasteboard.h
	* Source/NSPasteboard.m
	* Source/externs.m:
	Define new constants for NSPasteboard type identifiers. Most of them are
	aliases to the old "Pboard"-style types, although some new ones are not
	fully implemented.

2017-07-25  Daniel Ferreira <dtf@stanford.edu>

	* Headers/AppKit/NSSpeechSynthesizer.h:
	Modern applications require NSSpeechSynthesizerDelegate to be an actual
	@protocol in order to conform to it. Here, we allow it to be one if we
	are on an Objective-C runtime that supports it.

2017-07-22 Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSModelLoaderFactory.m (-supportedModelFileAtPath:): Fix
	bug found by compiler.

2017-07-22 Fred Kiefer <FredKiefer@gmx.de>

	* Headers/AppKit/NSEvent.h
	* Source/NSEvent.m: Add some newer Cocoa enums and one method with
	dummy implementation.

2017-07-09 Fred Kiefer <FredKiefer@gmx.de>

	* Headers/AppKit/NSEvent.h
	* Source/NSEvent.m: Add some newer Cocoa methods with dummy implementations.

2017-07-09 Fred Kiefer <FredKiefer@gmx.de>

	* .gitignore: Add a .gitignore file.

2017-06-17 Riccardo Mottola <rm@gnu.org>

	* Source/NSBitmapImageRep+JPEG.m
	Save resolution information if it is different from 72 dpi.

2017-06-13 Fred Kiefer <FredKiefer@gmx.de>

	* Source/externs.m: Added semicolons missing in last commit.
	* Source/NSSavePanel.m: Fix return type of sorting function.

2017-06-12 Ivan Vucica <ivan@vucica.net>

	* Source/NSAttributedString.m,
	* Source/externs.m:
	Merge pull request from TheDharc <brunosonic@gmail.com>.

2017-04-24 Riccardo Mottola <rm@gnu.org>

        * Source/tiff.m
	* Source/NSBitmapImageRep.m
	Support for writing resolution.

2017-04-22 Fred Kiefer <FredKiefer@gmx.de>

        * Version: Correct required base version that has been off for a year.

2017-04-16 Fred Kiefer <FredKiefer@gmx.de>

	* Printing/GSCUPS/GSCUPSPrinter.m: Add include to get deprecated
	function cupsGetPPD() on newer CUPS systems.

2017-04-16 Fred Kiefer <FredKiefer@gmx.de>

	* Model/IMLoading.m
	* Source/GSTextStorage.m
	* Source/GSToolbarView.m
	* Source/NSLayoutManager.m
	* Source/NSTableView.m
	Fix some clang static analyser warnings reported by
	Sebastian Reitenbach <sebastia@l00-bugdead-prods.de>.

2017-04-06 Ivan Vucica <ivan@vucica.net>

	* Releasing 0.25.1.

2017-04-05 Fred Kiefer <FredKiefer@gmx.de>

	* Headers/Additions/GNUstepGUI/GSXibKeyedUnarchiver.h: Moved from Source.
	* Headers/Additions/GNUstepGUI/GSXibLoading.h,
	* Source/GSXibLoader.m,
	* Source/GSXibKeyedUnarchiver.m,
	* Source/GNUmakefile: Use and install moved header file.

2017-04-01 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSMenu.m (-displayTransient): Update menu before displaying.
	* Source/NSMenuView.m (-attachSubmenuForItemAtIndex:): Use NSMenu
	display method.

2017-03-31 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSAttributedString.m: Check for surrogate UTF16
	characters to prevent nil strings when trying to attempt font
	substitution.

2017-03-31 Riccardo Mottola <rm@gnu.org>

	* Source/NSBitmapImageRep+JPEG.m (-_initBitmapFromJPEG:errorMessage:)
	Ignore density if unit is 0

2017-03-28 Riccardo Mottola <rm@gnu.org>

	* Source/NSBitmapImageRep+JPEG.m (-_initBitmapFromJPEG:errorMessage:)
	Parse density data and set size accordingly.

2017-03-24 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSBitmapImageRep+JPEG.m(-_JPEGRepresentationWithProperties:errorMessage:):
	Correct JPEG export which was using size instead of pixelsWide and pixelsHigh.

2017-03-20 Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSXibKeyedUnarchiver.m:
	Merge some of the changes from the testplant branch.

2017-03-19 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSBrowser.m: Add encoding of NSColumnsAutosaveName.
	* Headers/Additions/GNUstepGUI/GSXibLoading.h,
	* Source/GSXibLoader.m,
	* Source/GSXibKeyedUnarchiver.h,
	* Source/GSXibKeyedUnarchiver.m,
	* Source/GNUmakefile: Split of GSXibKeyedUnarchiver in separate file.
	* Source/GSXibLoading.m: Add description method for IBUserDefinedRuntimeAttribute.
	Merge some of the changes from the testplant branch.

2017-03-05 Fred Kiefer <FredKiefer@gmx.de>

	* Headers/AppKit/NSImage.h
	* Headers/AppKit/NSSplitView.h
	* Source/NSImage.m
	* Source/NSProgressIndicator.m
	* Source/NSTableHeaderView.m
	Merge some of the changes from the testplant branch.

2017-02-20 Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSHorizontalTypesetter.m (-layoutLineNewParagraph:): Add
	extra line fragment for empty string here.

2017-02-17 Fred Kiefer <FredKiefer@gmx.de>

	* Source/GSLayoutManager.m (-usedRectForTextContainer:): Add extra
	line rect when needed.
	* Source/NSTextView.m (sizeToFit): Don't add extra line rect, as
	it is now already included.
	* Source/NSStringDrawing.m (cache_lookup): Remove hack for empty string.

2017-02-12 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSStringDrawing.m: Use shared drawing code.
	* Source/NSStringDrawing.m (cache_lookup): Try to handle case of
	empty string.

2017-02-12 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSStringDrawing.m: Clean up string drawing cache code.

2017-01-08 Fred Kiefer <FredKiefer@gmx.de>

	* Source/NSMenu.m (-_isVisible, -_isMain): Add two helper
	methods. And make sure we update the menu items before display and
	keyEquivalent processing.
